Index: /trunk/LMDZ.PLUTO/libf/phypluto/initracer.F90
===================================================================
--- /trunk/LMDZ.PLUTO/libf/phypluto/initracer.F90	(revision 3194)
+++ /trunk/LMDZ.PLUTO/libf/phypluto/initracer.F90	(revision 3195)
@@ -3,12 +3,14 @@
       use surfdat_h, ONLY: dryness
       USE tracer_h
+      USE callkeys_mod, only: aerohaze,nb_monomer,haze,fractal,fasthaze,rad_haze
       USE recombin_corrk_mod, ONLY: ini_recombin
       USE mod_phys_lmdz_para, only: is_master, bcast
       use generic_cloud_common_h
+      use aerosol_mod, only: iaero_haze,i_haze
       IMPLICIT NONE
 !=======================================================================
 !   subject:
 !   --------
-!   Initialization related to tracer 
+!   Initialization related to tracer
 !   (transported dust, water, chemical species, ice...)
 !
@@ -23,6 +25,6 @@
 !            Ehouarn Millour (oct. 2008) identify tracers by their names
 !            Y Jaziri & J. Vatant d'Ollone (2020) : Modern traceur.def
-!            L Teinturier (2022): Tracer names are now read here instead of 
-!                                  inside interfaces 
+!            L Teinturier (2022): Tracer names are now read here instead of
+!                                  inside interfaces
 !=======================================================================
 
@@ -30,7 +32,11 @@
 
       character(len=500) :: tracline   ! to read traceur.def lines
-      ! character(len=30)  :: txt        ! to store some text
       integer :: blank      !to store the index of 1st blank when reading tracers names
       integer iq,ig,count,ierr
+      real r0_lift , reff_lift, rho_haze
+      integer nqhaze(nq)               ! to store haze tracers
+      integer i, ia, block
+      character(len=20) :: txt ! to store some text
+      CHARACTER(LEN=20) :: tracername ! to temporarily store text
 
 !-----------------------------------------------------------------------
@@ -86,11 +92,11 @@
          ENDDO
         ENDIF ! if modern or standard traceur.def
-       
+
        endif ! of if (is_master)
-       
+
        ! share the information with other procs/threads (if any)
        CALL bcast(nqtot)
        CALL bcast(moderntracdef)
-       
+
 !! -----------------------------------------------------------------------
        !! For the moment number of tracers in dynamics and physics are equal
@@ -108,5 +114,5 @@
        IF (.NOT.ALLOCATED(alpha_devil))    ALLOCATE(alpha_devil(nq))
        IF (.NOT.ALLOCATED(qextrhor))       ALLOCATE(qextrhor(nq))
-       IF (.NOT.ALLOCATED(igcm_dustbin))   ALLOCATE(igcm_dustbin(nq))
+      !  IF (.NOT.ALLOCATED(igcm_dustbin))   ALLOCATE(igcm_dustbin(nq))
        IF (.NOT.ALLOCATED(is_chim))        ALLOCATE(is_chim(nqtot))
        IF (.NOT.ALLOCATED(is_rad))         ALLOCATE(is_rad(nqtot))
@@ -140,5 +146,5 @@
        is_recomb_qset(:) = 0
        is_recomb_qotf(:) = 0
-       
+
        ! Added by JVO 2017 : these arrays are handled later
        ! -> initialization is the least we can do, please !!!
@@ -163,5 +169,5 @@
 
 ! Initialization: Read tracers names from traceur.def
-        do iq=1,nq 
+        do iq=1,nq
           if (is_master) read(407,'(A)') tracline
           call bcast(tracline)
@@ -173,49 +179,42 @@
       ! 0. initialize tracer indexes to zero:
       ! NB: igcm_* indexes are commons in 'tracer.h'
-      do iq=1,nq
-        igcm_dustbin(iq)=0
-      enddo
-      igcm_dust_mass=0
-      igcm_dust_number=0
-      igcm_h2o_vap=0
-      igcm_h2o_ice=0
-      igcm_co2=0
-      igcm_co=0
-      igcm_o=0
-      igcm_o1d=0
-      igcm_o2=0
-      igcm_o3=0
-      igcm_h=0
-      igcm_h2=0
-      igcm_oh=0
-      igcm_ho2=0
-      igcm_h2o2=0
       igcm_n2=0
-      igcm_n=0
-      igcm_n2d=0
-      igcm_no=0
-      igcm_no2=0
-      igcm_ar=0
-      igcm_ar_n2=0
-      igcm_n2_ice=0
-
-      igcm_ch4=0
-      igcm_ch3=0
-      igcm_ch=0
-      igcm_3ch2=0
-      igcm_1ch2=0
-      igcm_cho=0
-      igcm_ch2o=0
-      igcm_ch3o=0
-      igcm_c=0
-      igcm_c2=0
-      igcm_c2h=0
-      igcm_c2h2=0
-      igcm_c2h3=0
-      igcm_c2h4=0
-      igcm_c2h6=0
-      igcm_ch2co=0
-      igcm_ch3co=0
-      igcm_hcaer=0
+      igcm_ch4_gas=0
+      igcm_ch4_ice=0
+      igcm_prec_haze=0
+      igcm_co_gas=0
+      igcm_co_ice=0
+
+      nqhaze(:)=0
+      i=0
+      DO iq=1,nq
+         txt=noms(iq)
+         IF (txt(1:4).eq."haze") THEN
+            i=i+1
+            nqhaze(i)=iq
+         ENDIF
+      ENDDO
+      if ((haze.or.fasthaze).and.i==0) then
+         print*, 'Haze active but no haze tracer in traceur.def'
+         stop
+      endif
+
+      igcm_haze=0
+      igcm_haze10=0
+      igcm_haze30=0
+      igcm_haze50=0
+      igcm_haze100=0
+
+!     Eddy diffusion tracers
+      igcm_eddy1e6=0
+      igcm_eddy1e7=0
+      igcm_eddy5e7=0
+      igcm_eddy1e8=0
+      igcm_eddy5e8=0
+      write(*,*) 'initracer: noms() ', noms
+      rho_n2=1000        ! n2 ice
+      rho_ch4_ice=520.       ! rho ch4 ice
+      rho_co_ice=520.       ! rho ch4 ice
+      rho_haze=800.     ! haze
 
       ! 1. find dust tracers
@@ -224,218 +223,117 @@
       ! 2. find chemistry and water tracers
       do iq=1,nq
-        if (noms(iq).eq."co2") then
-          igcm_co2=iq
-          mmol(igcm_co2)=44.
-          count=count+1
-!          write(*,*) 'co2: count=',count
-        endif
-!         if (noms(iq).eq."co2_ice") then
-!           igcm_co2_ice=iq
-!           mmol(igcm_co2_ice)=44.
-!           count=count+1
-! !          write(*,*) 'co2_ice: count=',count
-!         endif
-        if (noms(iq).eq."h2o_vap") then
-          igcm_h2o_vap=iq
-          mmol(igcm_h2o_vap)=18.
-          count=count+1
-!          write(*,*) 'h2o_vap: count=',count
-        endif
-        if (noms(iq).eq."h2o_ice") then
-          igcm_h2o_ice=iq
-          mmol(igcm_h2o_ice)=18.
-          count=count+1
-!          write(*,*) 'h2o_ice: count=',count
-        endif
-        if (noms(iq).eq."co") then
-          igcm_co=iq
-          mmol(igcm_co)=28.
-          count=count+1
-        endif
-        if (noms(iq).eq."o") then
-          igcm_o=iq
-          mmol(igcm_o)=16.
-          count=count+1
-        endif
-        if (noms(iq).eq."o1d") then
-          igcm_o1d=iq
-          mmol(igcm_o1d)=16.
-          count=count+1
-        endif
-        if (noms(iq).eq."o2") then
-          igcm_o2=iq
-          mmol(igcm_o2)=32.
-          count=count+1
-        endif
-        if (noms(iq).eq."o3") then
-          igcm_o3=iq
-          mmol(igcm_o3)=48.
-          count=count+1
-        endif
-        if (noms(iq).eq."h") then
-          igcm_h=iq
-          mmol(igcm_h)=1.
-          count=count+1
-        endif
-        if (noms(iq).eq."h2") then
-          igcm_h2=iq
-          mmol(igcm_h2)=2.
-          count=count+1
-        endif
-        if (noms(iq).eq."oh") then
-          igcm_oh=iq
-          mmol(igcm_oh)=17.
-          count=count+1
-        endif
-        if (noms(iq).eq."ho2") then
-          igcm_ho2=iq
-          mmol(igcm_ho2)=33.
-          count=count+1
-        endif
-        if (noms(iq).eq."h2o2") then
-          igcm_h2o2=iq
-          mmol(igcm_h2o2)=34.
-          count=count+1
-        endif
         if (noms(iq).eq."n2") then
           igcm_n2=iq
           mmol(igcm_n2)=28.
           count=count+1
-        endif
-        if (noms(iq).eq."n2_ice") then
-          igcm_n2_ice=iq
-          mmol(igcm_n2_ice)=28.
-          count=count+1
-!          write(*,*) 'n2_ice: count=',count
-        endif
-        if (noms(iq).eq."ch4") then
-          igcm_ch4=iq
-          mmol(igcm_ch4)=16.
-          count=count+1
-        endif
-        if (noms(iq).eq."ar") then
-          igcm_ar=iq
-          mmol(igcm_ar)=40.
-          count=count+1
-        endif
-        if (noms(iq).eq."n") then
-          igcm_n=iq
-          mmol(igcm_n)=14.
-          count=count+1
-        endif
-        if (noms(iq).eq."no") then
-          igcm_no=iq
-          mmol(igcm_no)=30.
-          count=count+1
-        endif
-        if (noms(iq).eq."no2") then
-          igcm_no2=iq
-          mmol(igcm_no2)=46.
-          count=count+1
-        endif
-        if (noms(iq).eq."n2d") then
-          igcm_n2d=iq
-          mmol(igcm_n2d)=28.
-          count=count+1
-        endif
-        if (noms(iq).eq."ch3") then
-          igcm_ch3=iq
-          mmol(igcm_ch3)=15.
-          count=count+1
-        endif
-        if (noms(iq).eq."ch") then
-          igcm_ch=iq
-          mmol(igcm_ch)=13.
-          count=count+1
-        endif
-        if (noms(iq).eq."3ch2") then
-          igcm_3ch2=iq
-          mmol(igcm_3ch2)=14.
-          count=count+1
-        endif
-        if (noms(iq).eq."1ch2") then
-          igcm_1ch2=iq
-          mmol(igcm_1ch2)=14.
-          count=count+1
-        endif
-        if (noms(iq).eq."cho") then
-          igcm_cho=iq
-          mmol(igcm_cho)=29.
-          count=count+1
-        endif
-        if (noms(iq).eq."ch2o") then
-          igcm_ch2o=iq
-          mmol(igcm_ch2o)=30.
-          count=count+1
-        endif
-        if (noms(iq).eq."ch3o") then
-          igcm_ch3o=iq
-          mmol(igcm_ch3o)=31.
-          count=count+1
-        endif
-        if (noms(iq).eq."c") then
-          igcm_c=iq
-          mmol(igcm_c)=12.
-          count=count+1
-        endif
-        if (noms(iq).eq."c2") then
-          igcm_c2=iq
-          mmol(igcm_c2)=24.
-          count=count+1
-        endif
-        if (noms(iq).eq."c2h") then
-          igcm_c2h=iq
-          mmol(igcm_c2h)=25.
-          count=count+1
-        endif
-        if (noms(iq).eq."c2h2") then
-          igcm_c2h2=iq
-          mmol(igcm_c2h2)=26.
-          count=count+1
-        endif
-        if (noms(iq).eq."c2h3") then
-          igcm_c2h3=iq
-          mmol(igcm_c2h3)=27.
-          count=count+1
-        endif
-        if (noms(iq).eq."c2h4") then
-          igcm_c2h4=iq
-          mmol(igcm_c2h4)=28.
-          count=count+1
-        endif
-        if (noms(iq).eq."c2h6") then
-          igcm_c2h6=iq
-          mmol(igcm_c2h6)=30.
-          count=count+1
-        endif
-        if (noms(iq).eq."ch2co") then
-          igcm_ch2co=iq
-          mmol(igcm_ch2co)=42.
-          count=count+1
-        endif
-        if (noms(iq).eq."ch3co") then
-          igcm_ch3co=iq
-          mmol(igcm_ch3co)=43.
-          count=count+1
-        endif
-        if (noms(iq).eq."hcaer") then
-          igcm_hcaer=iq
-          mmol(igcm_hcaer)=50.
-          count=count+1
-        endif
-
+          write(*,*) 'Tracer ',count,' = n2'
+        endif
+        if (noms(iq).eq."ch4_gas") then
+          igcm_ch4_gas=iq
+          mmol(igcm_ch4_gas)=16.
+          count=count+1
+          write(*,*) 'Tracer ',count,' = ch4 gas'
+        endif
+        if (noms(iq).eq."ch4_ice") then
+          igcm_ch4_ice=iq
+          mmol(igcm_ch4_ice)=16.
+          radius(iq)=3.e-6
+          rho_q(iq)=rho_ch4_ice
+          count=count+1
+          write(*,*) 'Tracer ',count,' = ch4 ice'
+        endif
+        if (noms(iq).eq."co_gas") then
+          igcm_co_gas=iq
+          mmol(igcm_co_gas)=28.
+          count=count+1
+          write(*,*) 'Tracer ',count,' = co gas'
+        endif
+        if (noms(iq).eq."co_ice") then
+          igcm_co_ice=iq
+          mmol(igcm_co_ice)=28.
+          radius(iq)=3.e-6
+          rho_q(iq)=rho_co_ice
+          count=count+1
+          write(*,*) 'Tracer ',count,' = co ice'
+        endif
+        if (noms(iq).eq."prec_haze") then
+          igcm_prec_haze=iq
+          count=count+1
+          write(*,*) 'Tracer ',count,' = prec haze'
+        endif
+        if (noms(iq).eq."haze") then
+          igcm_haze=iq
+          count=count+1
+          radius(iq)=rad_haze
+          rho_q(iq)=rho_haze
+          write(*,*) 'Tracer ',count,' = haze'
+        endif
+        if (noms(iq).eq."haze10") then
+          igcm_haze10=iq
+          count=count+1
+          radius(iq)=10.e-9
+          rho_q(iq)=rho_haze
+          write(*,*) 'Tracer ',count,' = haze10'
+        endif
+        if (noms(iq).eq."haze30") then
+          igcm_haze30=iq
+          count=count+1
+          radius(iq)=30.e-9
+          rho_q(iq)=rho_haze
+          write(*,*) 'Tracer ',count,' = haze30'
+        endif
+        if (noms(iq).eq."haze50") then
+          igcm_haze50=iq
+          count=count+1
+          radius(iq)=50.e-9
+          rho_q(iq)=rho_haze
+          write(*,*) 'Tracer ',count,' = haze50'
+        endif
+        if (noms(iq).eq."haze100") then
+          igcm_haze100=iq
+          count=count+1
+          radius(iq)=100.e-9
+          rho_q(iq)=rho_haze
+          write(*,*) 'Tracer ',count,' = haze100'
+        endif
+!       Eddy diffusion tracers
+        if (noms(iq).eq."eddy1e6") then
+          igcm_eddy1e6=iq
+          count=count+1
+          write(*,*) 'Tracer ',count,' = eddy1e6'
+        endif
+        if (noms(iq).eq."eddy1e7") then
+          igcm_eddy1e7=iq
+          count=count+1
+          write(*,*) 'Tracer ',count,' = eddy1e7'
+        endif
+        if (noms(iq).eq."eddy5e7") then
+          igcm_eddy5e7=iq
+          count=count+1
+          write(*,*) 'Tracer ',count,' = eddy5e7'
+        endif
+        if (noms(iq).eq."eddy1e8") then
+          igcm_eddy1e8=iq
+          count=count+1
+          write(*,*) 'Tracer ',count,' = eddy1e8'
+        endif
+        if (noms(iq).eq."eddy5e8") then
+          igcm_eddy5e8=iq
+          count=count+1
+          write(*,*) 'Tracer ',count,' = eddy5e8'
+        endif
       enddo ! of do iq=1,nq
 
       ! 3. find condensable traceurs different from h2o and n2
       do iq=1,nq
-        if ((index(noms(iq),"vap") .ne. 0) .and. (index(noms(iq),"h2o") .eq. 0) .and. (index(noms(iq),"n2") .eq. 0)) then
-          count=count+1
-        endif
-        if ((index(noms(iq),"ice") .ne. 0) .and. (index(noms(iq),"h2o") .eq. 0) .and. (index(noms(iq),"n2") .eq. 0)) then
+        if ((index(noms(iq),"vap") .ne. 0) .and. (index(noms(iq),"n2") .eq. 0)) then
+          count=count+1
+        endif
+        if ((index(noms(iq),"ice") .ne. 0) .and. (index(noms(iq),"n2") .eq. 0)) then
           count=count+1
         endif
 
       enddo ! of do iq=1,nq
-      
+
       ! check that we identified all tracers:
       if (count.ne.nq) then
@@ -456,7 +354,7 @@
       if (is_master) then
        rewind(407)
-       do 
+       do
         read(407,'(A)') tracline
-        if (index(tracline,"#") .ne. 1) then 
+        if (index(tracline,"#") .ne. 1) then
           exit
         endif
@@ -502,5 +400,5 @@
       n_rgcs = sum(is_rgcs)
       write(*,*)'Number of Radiative Generic Condensable Species is n_rgcs = ',n_rgcs
-      if (n_rgcs> ngt/2) then 
+      if (n_rgcs> ngt/2) then
         write(*,*) 'You have more Radiative Generic Condensable Species than Generic Condensable Species'
         write(*,*)'This is not possible: check your Modern traceur.def'
@@ -523,5 +421,5 @@
       lw_ch4=586700.
       lw_n2=2.5e5
-      
+
       if (haze) then
         ! the sedimentation radius remains radius(igcm_haze)
@@ -530,5 +428,5 @@
         else
            nmono=1
-        endif  
+        endif
 
         ia=0
@@ -539,14 +437,14 @@
 
            block=0  ! Only one type of haze is active : the first one set in traceur.def
-           do iq=1,nqmx
+           do iq=1,nq
              tracername=noms(iq)
-             write(*,*) "--> tracername ",iq,'/',nqmx,' = ',tracername
+             write(*,*) "--> tracername ",iq,'/',nq,' = ',tracername
              if (tracername(1:4).eq."haze".and.block.eq.0) then
                i_haze=iq
                block=1
                write(*,*) "i_haze=",i_haze
-               write(*,*) "Careful: if you set many haze traceurs in 
-    & traceur.def,only ",tracername," will be radiatively active 
-    & (first one in traceur.def)"
+               write(*,*) "Careful: if you set many haze traceurs in&
+     traceur.def,only ",tracername," will be radiatively active&
+     (first one in traceur.def)"
              endif
            enddo
@@ -563,5 +461,5 @@
       write(*,*) 'alpha_devil = ', alpha_devil
       write(*,*) 'radius  = ', radius
-      write(*,*) 'Qext  = ', qext 
+      write(*,*) 'Qext  = ', qext
       write(*,*)
 
@@ -579,5 +477,5 @@
           integer,           intent(in) :: iq       ! tracer index
           character(len=500),intent(in) :: tracline ! traceur.def lines with parameters
-  
+
           read(tracline,*) noms(iq)
           ! JVO 20 : We should add a sanity check aborting when duplicates in names !
@@ -593,5 +491,5 @@
                  mmol(iq)
           end if
-          ! option aki 
+          ! option aki
           if (index(tracline,'aki='   ) /= 0) then
               read(tracline(index(tracline,'aki=')+len('aki='):),*) &
@@ -603,5 +501,5 @@
                   aki(iq)
           end if
-          ! option cpi 
+          ! option cpi
           if (index(tracline,'cpi='   ) /= 0) then
               read(tracline(index(tracline,'cpi=')+len('cpi='):),*) &
@@ -613,5 +511,5 @@
                   cpi(iq)
           end if
-          ! option is_chim 
+          ! option is_chim
           if (index(tracline,'is_chim='   ) /= 0) then
           read(tracline(index(tracline,'is_chim=')+len('is_chim='):),*) &
@@ -623,5 +521,5 @@
                   is_chim(iq)
           end if
-          ! option is_rad 
+          ! option is_rad
           if (index(tracline,'is_rad=') /= 0) then
               read(tracline(index(tracline,'is_rad=') &
@@ -668,15 +566,15 @@
           end if
           !option is_condensable (LT)
-          if (index(tracline,'is_condensable=') /=0) then 
+          if (index(tracline,'is_condensable=') /=0) then
             read(tracline(index(tracline,'is_condensable=') &
               +len('is_condensable='):),*) is_condensable(iq)
             write(*,*) ' Parameter value (traceur.def) :'// &
-              ' is_condensable=', is_condensable(iq)       
+              ' is_condensable=', is_condensable(iq)
           else
               write(*,*) ' Parameter value (default)     :'// &
-              ' is_condensable=', is_condensable(iq)       
+              ' is_condensable=', is_condensable(iq)
           endif
           !option radius
-          if (index(tracline,'radius=') .ne. 0) then 
+          if (index(tracline,'radius=') .ne. 0) then
             read(tracline(index(tracline,'radius=') &
               +len('radius='):),*) radius(iq)
@@ -685,8 +583,8 @@
           else
             write(*,*) ' Parameter value (default)     :'// &
-            ' radius=', radius(iq)," m"     
+            ' radius=', radius(iq)," m"
           endif
           !option rho
-          if (index(tracline,'rho=') .ne. 0) then 
+          if (index(tracline,'rho=') .ne. 0) then
             read(tracline(index(tracline,'rho=') &
               +len('rho='):),*) rho_q(iq)
@@ -695,8 +593,8 @@
           else
             write(*,*) ' Parameter value (default)     :'// &
-              ' rho=', rho_q(iq)       
+              ' rho=', rho_q(iq)
           endif
-          !option is_rgcs 
-          if (index(tracline,'is_rgcs') .ne. 0) then 
+          !option is_rgcs
+          if (index(tracline,'is_rgcs') .ne. 0) then
             read(tracline(index(tracline,'is_rgcs=') &
               +len('is_rgcs='):),*) is_rgcs(iq)
Index: /trunk/LMDZ.PLUTO/libf/phypluto/phys_state_var_mod.F90
===================================================================
--- /trunk/LMDZ.PLUTO/libf/phypluto/phys_state_var_mod.F90	(revision 3194)
+++ /trunk/LMDZ.PLUTO/libf/phypluto/phys_state_var_mod.F90	(revision 3195)
@@ -13,6 +13,4 @@
       use comsaison_h, only: mu0, fract
       use radcommon_h, only: glat
-!      use slab_ice_h, only : noceanmx
-      ! USE ocean_slab_mod, ONLY: nslay
       USE radinc_h, only : L_NSPECTI, L_NSPECTV,naerkind
       use surfdat_h, only: phisfi, albedodat,  &
@@ -73,5 +71,5 @@
       real,dimension(:,:,:),allocatable,save :: int_dtauv   ! VI optical thickness of layers within narrowbands for diags ().
       real,dimension(:,:,:),allocatable,save :: int_dtaui   ! IR optical thickness of layers within narrowbands for diags ().
-!$OMP THREADPRIVATE(int_dtaui,int_dtauv) 
+!$OMP THREADPRIVATE(int_dtaui,int_dtauv)
 
       real,allocatable,dimension(:),save :: tau_col ! Total Aerosol Optical Depth.
@@ -100,5 +98,5 @@
       real,dimension(:,:),allocatable,save :: lscaledEz ! Heat from largescale (W.m-2)
 !$OMP THREADPRIVATE(madjdE,madjdEz,lscaledE,lscaledEz)
-      
+
       real,dimension(:),allocatable,save :: genericconddE ! Heat from generic condensation (W.m-2)
 !$OMP THREADPRIVATE(genericconddE)
@@ -122,5 +120,5 @@
 !zpic(:)   ! Maximum de l'OESM
 !zval(:)   ! Minimum de l'OESM
-!rugoro(:) ! longueur de rugosite de l'OESM 
+!rugoro(:) ! longueur de rugosite de l'OESM
 
         ALLOCATE(phisfi(klon))
